* PACKAGE P2ICEM  !" ʪ(2) ɹǥ
*
*"                ɽ̲٤˱ɹĥ餹
*" 98/11/19             
*" 2006/03/15     κؤη׻äƤߤ
*"
***********************************************************************
      SUBROUTINE SEAICE
     M         ( GDHI  , GDTO  , 
     M           GTTG  ,
     I           UFLUX , VFLUX, 
     I           GDTG  , 
     I           TFLUX , QFLUX , RFLUX , SFLUX ,
     I           DELTM ,
     C           ALAT                           )
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZHDIM)                      !" ʸʸ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zhdim.F"                    !" ʸʸ
#endif
*
*   [MODIFY] 
      REAL       GDHI  ( IDIM*JDIM       )   !" ɹθ
      REAL       GDTO  ( IDIM*JDIM       )   !" κز
*   [INPUT] 
      REAL       UFLUX ( IDIM*JDIM )         !"  flux ǲؤ
      REAL       VFLUX ( IDIM*JDIM )         !"  flux ǲؤ
      REAL       GDTG  ( IDIM*JDIM )         !" ɽ̲
      REAL       GTTG  ( IDIM*JDIM )         !" ɽѲΨ
      REAL       TFLUX ( IDIM*JDIM, KMAX+1 ) !" ԤΥեå
      REAL       QFLUX ( IDIM*JDIM, KMAX+1 ) !" Υեå
      REAL       RFLUX ( IDIM*JDIM, KMAX+1 ) !" Ĺȥեå
      REAL       SFLUX ( IDIM*JDIM, KMAX+1 ) !" ûȥեå
      REAL       ALAT  ( JDIM )              !" 
*
      REAL       DELTM                       !" ǥֹ t
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      REAL       FM                          !" ɹɽز
      REAL       FB                          !" ɹɽز
      REAL       FT                          !" ɹɽز
      REAL       QM                          !" ɹɽز
      REAL       QMALL                       !" ɹɽز
      REAL       NGDHI                       !" ѿ( Hi)
      REAL       NGDTT                       !" ѿ( Tt)

      INTEGER    ITIM
      REAL       DELTICE                     !" ice model t

      COMMON    /COMWRK/
     &           GDTT, GBTG, CORIOL, GDUO1L, GDVO1L
      REAL       GDTT  ( IDIM, JDIM )         !" ɹɽز
      REAL       GBTG  ( IDIM, JDIM )         !" ƥåɽ̲
*"  added 2006/03/16
      REAL       CORIOL (IDIM*JDIM)         !" Coliolis
      REAL       GDUO1L (IDIM*JDIM)         !" U Ocean upper layer
      REAL       GDVO1L (IDIM*JDIM)         !" V Ocean upper layer
      REAL       GDTGX  (IDIM*JDIM)         !" V Ocean upper layer
      REAL       GDTGY  (IDIM*JDIM)         !" V Ocean upper layer
      REAL       WTGX   (NMDIM)
      REAL       WTGY   (NMDIM)
*
*   [INTERNAL PARM] 
      REAL       HIMIN                       !" ICE κǾ
      REAL       TB                          !" ICE β
      REAL       TFREZ                       !" ɹ
      REAL       TMELT                       !" melting point
      REAL       ELF                         !"  <-> ɹ Ǯ
      REAL       ELC                         !" <->ɹ Ǯ
      REAL       CW                          !" Ǯ
      REAL       CICE                        !" ICE Ǯ
      REAL       RHOW                        !" ̩
      REAL       RHOI                        !" ICE ̩
      REAL       DMIXL                       !" ؤθ
      REAL       KW                          !" Ǯ͢
      REAL       KICE                        !" ICE Ǯ͢
      REAL       HS6                         !" ʿǮflux
*" added M. Ishiwatari (2006/03/16)
      REAL       RHOML                        !" density of Mixed Layer
      REAL       RS                           !" damping coeff. of ekman vel.
      REAL       CPML                          !" specific heat of M.L.
      REAL       H1                          !" depth of M.L.
      REAL       H2                          !" depth of sub M.L.
      REAL       HOUL                        !" depth of ocean upper layer
      INTEGER    NSTPIM                      !" ƥå׿
      DATA       HIMIN  /       0.02 /
      DATA       TB     /     271.0  /
      DATA       TFREZ  /     271.0  /
      DATA       TMELT  /     272.9  /
      DATA       ELF    /  330000.0  /
      DATA       ELC    / 2500000.0  /
      DATA       CW     /    4220.0  /
      DATA       CICE   /    2100.0  /
      DATA       RHOW   /    1000.0  /
      DATA       RHOI   /     900.0  /
      DATA       DMIXL  /      50.0  /
      DATA       KW     /     400.0  /
      DATA       KICE   /       2.0  /
      DATA       HS6    /       0.0  /
      DATA       NSTPIM /       100  /
*" added M. Ishiwatari (2006/03/16)
      DATA       RHOML /      1.0d3 /
      DATA       RS    /   5.787d-6 /
      DATA       CPML  /      4.0d3 /
      DATA       H1    /     50.0d0 /
      DATA       H2    /    150.0d0 /
      DATA       H     /    200.0d0 /
      NAMELIST   /NMICEM/ HIMIN, TB, TFREZ, TMELT,ELF, ELC, CW, CICE, 
     &                    RHOW, RHOI, DMIXL, KW, KICE, HS6, NSTPIM
*
*   [ONCE] 
      IF ( OFIRST ) THEN
*         OFIRST = .FALSE.
         WRITE ( 6,* ) ' ICE MODEL DATE(mixlayer)=2006/03/17'
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMICEM, END=1190 )
 1190    WRITE  ( JFPAR, NMICEM )
      ENDIF
*
      DO 1100 IJ = 1, IDIM*JDIM
         GBTG( IJ ) = GDTG( IJ )
 1100 CONTINUE
*
      DO 2100 IJ = 1, IDIM*JDIM
         GDTT( IJ ) = GBTG( IJ ) + GTTG( IJ ) * DELTM
         IF ( GDTT  ( IJ ) .LE. TFREZ) THEN  !" ǽɹĥ
            GDHI( IJ ) = HIMIN
            GDTO( IJ ) = GDTT( IJ ) 
         ELSE                                !" ɹ̵
            GDHI( IJ ) = 0.0
            GDTO( IJ ) = GDTT( IJ )
         END IF
 2100 CONTINUE

*
*"  ׻ʤ褦ʵ⤹뤱, θ GTTG( IJ ) ѹ
*" ׻Ƥޤ.

*" Coliolis parameter
      IDAYL  =  24.0d0 * 3600.0d0
      PI     = ATAN ( 1. )*4.
      OMEGA  = 2. *PI / DBLE( IDAYL )
*
      DO 3100 J = 1, JDIM
         DO 3110 I = 1, IDIM
            CORIOL ( I+IDIM*(J-1) ) = 2. *OMEGA * SIN( ALAT( J ) )
 3110    CONTINUE
 3100 CONTINUE

*" Ocean Current
      DO 4100 IJ = 1, IDIM*JDIM
          GDUO1L (IJ) = H2 / H /RHOML / H1 
     &            / (RS**2 + CORIOL(IJ)**2 )
     &           * ( RS * UFLUX (IJ) + CORIOL(IJ) * VFLUX(IJ) )
         GDVO1L (IJ) = H2 / H /RHOML / H1 
     &            / (RS**2 + CORIOL(IJ)**2 )
     &           * ( RS * UFLUX (IJ) )
     &           * ( - CORIOL(IJ)*UFLUX(IJ) + RS*VFLUX(IJ) )
 4100 CONTINUE

*" GDTG modify      
      IF ( OFIRST ) THEN
         OFIRST = .FALSE.
      ELSE
         CALL G2W
     O         ( WTGX ,
     I           GDTG  ,
     I           'XGRA', 'POS ', 1  )

         CALL W2G
     O         ( GDTGX ,
     I           WTGX  ,
     I           '   ', 'POS ', 1  )

         CALL G2W
     O         ( WTGY ,
     I           GDTG  ,
     I           'YGRA', 'NEG ', 1  )

         CALL W2G
     O         ( GDTGY ,
     I           WTGY  ,
     I           '   ', 'POS ', 1  )

        DO 5100 I = 1, IDIM*JDIM
          GTTG(IJ) = GTTG(IJ) 
     &       + (  GDUO1L(IJ)*GDTGX(IJ) + GDVO1L(IJ)*GDTGY(IJ) )
     &         * (HIMIN - GDHI(IJ) )/ HIMIN
 5100   CONTINUE
      ENDIF  

      RETURN
      END
