* PACKAGE P2ZFLT  !" $BJ*M}2aDx(B(2) $B1tD>J}8~$K%U%#%k%?$r$+$1$k(B(T $B$N$_(B)
*
*"$BMzNr(B 95/04/05 $B@PEO@5<y(B            
*"
***********************************************************************
      SUBROUTINE VERFLT      !" $B1tD>J}8~$N%U%#%k%?(B
     M         ( GDU  , GDV  , GDT  ,
     O           GTUZF, GTVZF, GTTZF,
     I           DELTA, GDPM  ) 
*
*"  $B1tD>J}8~$N%U%#%k%?(B: Shapiro (1971)
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" $B29EY(B  $B#T(B
      REAL       GDU   ( IDIM, JDIM, KMAX )  !" $BEl@>Iw(B $B#U(B($B%@%_!<(B)
      REAL       GDV   ( IDIM, JDIM, KMAX )  !" $BFnKLIw(B $B#V(B($B%@%_!<(B)
*
*   [INPUT]
      REAL       GDPM  ( IDIM, JDIM, KMAX+1 )  !" ($B%@%_!<(B)
*
*   [INTERNAL PARM]
      REAL    SH                               !" $B%U%#%k%?78?t(B
      REAL    SM                               !" $B%U%#%k%?78?t(B
      DATA    SH  / 0.5 /
      DATA    SM  / 0.5 /
*
      NAMELIST  /NMZFLT/ SH,SM
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IFPAR, JFPAR
*
*   [OUTPUT] 
      REAL       GTTZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#TJQ2=N((B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' Z FILTER PACKAGE - DATE=95/04/05'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMZFLT, END=190 )
  190    WRITE  ( JFPAR, NMZFLT )
      ENDIF
*
      CALL RESET ( GTTZF, IDIM*JDIM*KMAX )
*
      DO 1200 J=1,JDIM
         DO 1200 I=1,IDIM
            GTTZF(I,J,1) = S/2.0*(GDT(I,J,2)-GDT(I,J,1))
            DO 1100 K=2, KMAX-1
                  GTTZF(I,J,K)
     &          = S/2.0*(GDT(I,J,K-1)-2.0*GDT(I,J,K)+GDT(I,J,K+1))
 1100       CONTINUE 
            GTTZF(I,J,KMAX) = S/2.0*(GDT(I,J,KMAX-1)-GDT(I,J,KMAX))
 1200 CONTINUE 
*
      DO 2100 I = 1, IDIM
         DO 2100 J = 1, JDIM
            DO 2100 K=1,KMAX
               GDT(I,J,K) = GDT(I,J,K) + GTTZF(I,J,K)
 2100 CONTINUE 
*
      RETURN
      END


