* PACKAGE P2GRST      !" ʪ(2) ˰
*
*"  [HIS] 95/09/22(ishiwatari)
*"        95/10/05(ishiwatari) ˸Фޤ
*"        95/10/30(ishiwatari) ǥХå, ؤǼ¹
*
**********************************************************************
      SUBROUTINE GRVSAT   !" ˰
     M         ( GDT   , GDU   , GDV   ,
     O           GTGS  , GUGS  , GVGS  ,
     I           GDTM  , GDP   , GDPM  , DELTA  )
*
*" ؤĴ᤹. 
*"  3 ȥꥪĴᤷƤ, Ϥ 3 ˤФޤ.
*" p2grst.F ǤϤ.
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" ʻȿ
      INCLUDE   (ZCCOM)                      !" ɸʪ
#else
#include        "zcdim.F"                    !" ʻȿ
#include        "zccom.F"                    !" ɸʪ
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDU   ( IDIM*JDIM, KMAX )   !" 
      REAL       GDV   ( IDIM*JDIM, KMAX )   !" 
*
*   [INPUT] 
      REAL       GDP   ( IDIM*JDIM, KMAX )   !"   
      REAL       GDPM  ( IDIM*JDIM, KMAX+1 ) !" Ⱦ
      REAL       GDTM  ( IDIM*JDIM, KMAX+1 ) !" ١Ⱦ
      REAL       DELTA                       !" 2 t
*
*   [OUTPUT] 
      REAL       GTGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
      REAL       GUGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
      REAL       GVGS   ( IDIM*JDIM, KMAX )   !" ѲΨ
*
*   [INTERNAL PARM] 
      REAL       FGS                         !" Ĵ᤹ٹ
      INTEGER    KMINGS                      !" Ĵᳫϥ٥
      INTEGER    KMAXGS                      !" ĴὪλ٥
      DATA       FGS    / 1.0 /
      DATA       KMINGS / 2   /
*"          :KMAXGS ΥǥեͤϲǷ.
*
      NAMELIST /NMGRST/ FGS, KMINGS, KMAXGS
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           DELP, TB, GDTB
      REAL       DELP  ( IDIM*JDIM, KMAX )   !" 
      REAL       TB    ( IDIM*JDIM, KMAX )   !" T ܾ
      REAL       GDTB  ( IDIM*JDIM, KMAX )   !" (Ĵ)
      INTEGER    IJ, K, K1
      INTEGER    IFPAR, JFPAR
      REAL       SUMTDP, SUMADP
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' GRAVITY WAVE SATURATION P2.1 DATE=95/10/09'
         OFIRST = .FALSE.
*
         KMAXGS = KMAX-1
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMGRST, END=190 )
  190    WRITE  ( JFPAR, NMGRST )
*
      ENDIF
*
*"      < 1. ե׻ >
*
      DO 1100 K = 1, KMAX
         DO 1100 IJ = 1, IDIM*JDIM
            DELP  ( IJ,K ) = GDPM( IJ,K   ) - GDPM( IJ,K+1 )
            TB    ( IJ,K ) = (GDTM( IJ,K ) + GDTM( IJ,K+1 ))/2.0
 1100 CONTINUE
*
*"      < 2. Ĵ >
*
      CALL RESET ( GTGS, IDIM*JDIM*KDIM )
      CALL RESET ( GUGS, IDIM*JDIM*KDIM )
      CALL RESET ( GVGS, IDIM*JDIM*KDIM )
*
      SUMTDP=0.0
      SUMADP=0.0
*
      DO 2110 K = KMINGS, KMAXGS
         DO 2120 IJ = 1, IDIM*JDIM
            SUMTDP =  (TB(IJ,K-1) - GDT(IJ,K-1) ) * DELP(IJ,K-1)
     &              + (TB(IJ,K  ) - GDT(IJ,K  ) ) * DELP(IJ,K  )
     &              + (TB(IJ,K+1) - GDT(IJ,K+1) ) * DELP(IJ,K+1)
            SUMADP =  DELP(IJ,K-1) + DELP(IJ,K) + DELP(IJ,K+1)
*
            GDT(IJ,K-1) = GDT(IJ,K-1)
     &                    + FGS*(   TB(IJ,K-1) - GDT(IJ,K-1) 
     &                            - SUMTDP/SUMADP )
*
            GDT(IJ,K) = GDT(IJ,K)
     &                    + FGS*(   TB(IJ,K) - GDT(IJ,K) 
     &                            - SUMTDP/SUMADP )
*
            GDT(IJ,K+1) = GDT(IJ,K+1) 
     &                    + FGS*(   TB(IJ,K+1) - GDT(IJ,K+1) 
     &                            - SUMTDP/SUMADP )
 2120    CONTINUE
 2110 CONTINUE
*
      DO 2210 K=1,KMAX
         DO 2220 IJ = 1, IDIM*JDIM
            GTGS(IJ,K) = ( GDT(IJ,K) - GDTB(IJ,K) )/DELTA
 2220    CONTINUE
 2210 CONTINUE
*
      RETURN
      END
