* PACKAGE P2PCOR !" $BJ*M}2aDx(B(2) $B6E7k!&>xH/$K$h$kBg5$<ANL$NJd@5(B
*
*********************************************************************
      SUBROUTINE PSQCOR    !" $B6E7k!&>xH/$K$h$kBg5$<ANL$NJd@5(B
     M         ( GDQ   , GDPS,
     I           QFLUX , GSCND,
     I           GDPM  ,
     I           DELTA          )
*
*"     $B6E7k!&>xH/$K$h$kBg5$<ANL$NJd@5(B
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                       !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                     !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY]
      REAL       GDQ    ( IDIM*JDIM, KMAX )   !" $BHf<>(B  $B#q(B
      REAL       GDPS   ( IDIM*JDIM )   !" Ps
*
*   [INPUT]     
      REAL       GDPM   ( IDIM*JDIM, KMAX+1 ) !" $B5$05(B($BH>@0?t(B)
      REAL       QFLUX   ( IDIM*JDIM, KMAX+1 ) !" q $B%U%i%C%/%9(B
      REAL       GSCND   ( IDIM*JDIM, KMAX ) !" q $B6E7kNL(B
      REAL       DELTA                        !" 2$B&$(Bt
*
*   [INTERNAL WORK] 
      COMMON    /COMWRK/
     &           DELP  , DELPS
      REAL       DELP  ( IDIM*JDIM, KMAX )   !" $B&$#p(B
      REAL       DELPS ( IDIM*JDIM )   !" Ps $BJQ2=NL(B
*
      INTEGER    IJ, K
      INTEGER    IMAXD, JMAXD, KMAXD
*
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE       OFIRST
*
*   [ONCE] 
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' MASS CORRECTION P2.2 DATE=95/11/20'
         OFIRST = .FALSE.
      ENDIF
*
*"         << 1. $B=`Hw(B >>
*
      DO 1100 K = 1, KMAX
         DO 1110 IJ = 1, IDIM*JDIM
            DELP( IJ,K ) = GDPM( IJ,K ) - GDPM( IJ,K+1 )
 1110    CONTINUE
 1100 CONTINUE
*
*"         << 2. $BBg5$A}2CNL(B >>
*
      DO 2110 IJ = 1, IDIM*JDIM
         DELPS(IJ) = QFLUX(IJ,1)/EL*GRAV *DELTA * 0.01
         DO 2100 K = 1, KMAX
            DELPS(IJ) = DELPS(IJ)
     &                 + GSCND(IJ,K) * DELTA * DELP(IJ,K) * 0.01
 2100    CONTINUE
 2110 CONTINUE
*
*"         << 3. q $B$NCM$NJd@5(B >>
*
      DO 3100 K = 1, KMAX
         DO 3110 IJ = 1, IDIM*JDIM
            GDQ ( IJ,K )
     &    = GDPS(IJ) /( GDPS(IJ) + DELPS(IJ) )* GDQ(IJ,K)
 3110    CONTINUE
 3100 CONTINUE
*
*"         << 4. Ps $B$NCM$NJd@5(B >>
*
      DO 4010  IJ = 1, IDIM*JDIM
         GDPS ( IJ ) = GDPS(IJ) + DELPS(IJ)
 4010 CONTINUE
*
*"         << 5. $B%b%K%?!<(B >>
*
      RETURN
      END
