* PACKAGE P2UDMP  !" $BJ*M}2aDx(B(2) $B>eAX$G$NGH$N8:?j(B($BA45eJ?6Q$X8:?j(B)
*
*"$BMzNr(B 94/11/10 $B@PEO@5<y(B            
*"$BMzNr(B 94/12/15 $B@PEO@5<y(B  $B%P%0%U%#%C%/%9(B
*"
***********************************************************************
      SUBROUTINE UPDAMP      !" $B>eAX$G$NGH$N8:?j(B
     O         ( UDUG   , UDVG   , UDTG , 
     I           GDU    , GDV    , GDT  ) 
*
*"  $B>eAX$N8:?j!'(B $BB.EY%l%$%j!<K`;$(B, $B29EY%K%e!<%H%sNd5Q(B
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [INPUT] 
      REAL       GDU   ( IDIM, JDIM, KMAX )  !" $B@>Iw(B  $B#u(B
      REAL       GDV   ( IDIM, JDIM, KMAX )  !" $BFnIw(B  $B#v(B
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" $B29EY(B  $B#T(B
*
*   [OUTPUT]
      REAL       UDUG   ( IDIM, JDIM, KMAX )   !" $B>eAX8:?j#UJQ2=(B
      REAL       UDVG   ( IDIM, JDIM, KMAX )   !" $B>eAX8:?j#VJQ2=(B
      REAL       UDTG   ( IDIM, JDIM, KMAX )   !" $B>eAX8:?j#TJQ2=(B
*
*   [INTERNAL PARM]
      INTEGER    NDLYRD
      PARAMETER (NDLYRD = 10)
      INTEGER    NDLYR                        !" $B%9%]%s%8AX?t(B
      REAL    DTIMEM(NDLYRD)                  !" $BB.EY4KOB;~4V(B
      REAL    DTIMET(NDLYRD)                  !" $B29EY4KOB;~4V(B
      DATA    NDLYR  / 3 /
      DATA    DTIMEM / 10800 , 10800 , 10800 , 0.0 , 0.0, 
     &                 0.0   , 0.0   , 0.0   , 0.0 , 0.0 /
      DATA    DTIMET / 10800 , 10800 , 10800 , 0.0 , 0.0,
     &                 0.0   , 0.0   , 0.0   , 0.0 , 0.0 /
*
      NAMELIST  /NMUDMP/ NDLYR , DTIMEM , DTIMET
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IFPAR, JFPAR
      REAL       MGDU  ( KMAX )        !" $B#UJ?6Q(B
      REAL       MGDV  ( KMAX )        !" $B#VJ?6Q(B
      REAL       MGDT  ( KMAX )        !" $B#TJ?6Q(B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' UPPER DAMPING PACKAGE - DATE=95/02/09'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMUDMP, END=190 )
  190    WRITE  ( JFPAR, NMUDMP )
      ENDIF
*
*
      CALL RESET ( UDUG, IDIM*JDIM*KMAX )
      CALL RESET ( UDVG, IDIM*JDIM*KMAX )
      CALL RESET ( UDTG, IDIM*JDIM*KMAX )
*
      CALL RESET ( MGDU, KMAX )
      CALL RESET ( MGDV, KMAX )
      CALL RESET ( MGDT, KMAX )
*
      DO 1200 K=1, KMAX
         DO 1100 J=1,JDIM
            DO 1100 I=1,IDIM
               MGDU(K) = MGDU(K) + GDU(I,J,K)
               MGDV(K) = MGDV(K) + GDV(I,J,K)
               MGDT(K) = MGDT(K) + GDT(I,J,K)
 1100       CONTINUE 
            MGDU(K) = MGDU(K)/Real(IDIM*JDIM)
            MGDV(K) = MGDV(K)/Real(IDIM*JDIM)
            MGDT(K) = MGDT(K)/Real(IDIM*JDIM)
*"                $B$3$l$O@53N$G$J$$(B.
 1200 CONTINUE 
*
*      write (6,*) 'in p2udmp: after 1200'
      DO 2100 I = 1, IDIM
         DO 2100 J = 1, JDIM
            DO 2100 K=KMAX,KMAX-NDLYR+1,-1
               UDUG(I,J,K) = - 1.0/DTIMEM(K+NDLYR-KMAX) * 
     &                     ( GDU(I,J,K) - MGDU(K) )
               UDVG(I,J,K) = - 1.0/DTIMEM(K+NDLYR-KMAX) * 
     &                     ( GDV(I,J,K) - MGDV(K) )
               UDTG(I,J,K) = - 1.0/DTIMET(K+NDLYR-KMAX) * 
     &                     ( GDT(I,J,K) - MGDT(K) )
 2100 CONTINUE 
*
c$$$      write (6,*) 'in p2udmp: after 2100'
*
      RETURN
      END


