* PACKAGE P2ZFLT  !" $BJ*M}2aDx(B(2) $B1tD>J}8~$K%U%#%k%?$r$+$1$k(B
*
*"$BMzNr(B 95/04/05 $B@PEO@5<y(B            
*"$BMzNr(B 95/05/02 $B@PEO@5<y(B            
*"$BMzNr(B 95/10/30 $B@PEO@5<y(B  T $B$N8m:9$rA4AX$K$P$i$^$/(B
*"
***********************************************************************
      SUBROUTINE VERFLT      !" $B1tD>J}8~$N%U%#%k%?(B
     M         ( GDU  , GDV  , GDT  ,
     O           GTUZF, GTVZF, GTTZF,
     I           DELTA, GDPM  ) 
*
*"  $B1tD>J}8~$N%U%#%k%?(B: Shapiro (1971)
*
*   [PARAM] 
#ifdef SYS_IBMS
      INCLUDE   (ZCDIM)                      !" $B3J;RE@?t!$GH?t(B
      INCLUDE   (ZCCOM)                      !" $BI8=`J*M}Dj?t(B
#else
#include        "zcdim.F"                    !" $B3J;RE@?t!$GH?t(B
#include        "zccom.F"                    !" $BI8=`J*M}Dj?t(B
#endif
*
*   [MODIFY] 
      REAL       GDT   ( IDIM, JDIM, KMAX )  !" $B29EY(B   $B#T(B
      REAL       GDU   ( IDIM, JDIM, KMAX )  !" $BEl@>Iw(B $B#U(B
      REAL       GDV   ( IDIM, JDIM, KMAX )  !" $BFnKLIw(B $B#V(B
*
*   [INPUT]
      REAL       GDPM  ( IDIM, JDIM, KMAX+1 )  !" 
*
*   [INPUT]
      REAL    DELTA
*
*   [INTERNAL PARM]
      REAL    SH                               !" $B%U%#%k%?78?t(B
      REAL    SM                               !" $B%U%#%k%?78?t(B
      DATA    SH / 0.5 /
      DATA    SM / 0.5 /
*
      NAMELIST  /NMZFLT/ SH,SM
      SAVE
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IFPAR, JFPAR
      REAL       SUMTDP
      REAL       SUMADP
      REAL       DELP  ( IDIM, JDIM, KMAX+1 )
*
*   [OUTPUT] 
      REAL       GTTZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#TJQ2=N((B
      REAL       GTUZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#UJQ2=N((B
      REAL       GTVZF   ( IDIM, JDIM, KMAX )   !" $B%U%#%k%?#VJQ2=N((B
*
*   [INTERNAL SAVE] 
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
      SAVE
*
*   [ONCE]
      IF ( OFIRST ) THEN
         WRITE ( 6,* ) ' Z FILTER PACKAGE - DATE=95/10/30'
         OFIRST = .FALSE.
*
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMZFLT, END=190 )
  190    WRITE  ( JFPAR, NMZFLT )
      ENDIF
*
*"   < 1. $B%U%!%/%?!<7W;;!&%j%;%C%H(B>
*
      DO 1100 K = 1, KMAX
         DO 1100 I = 1, IDIM
            DO 1100 J = 1, JDIM
               DELP  ( I,J,K ) = GDPM( I,J,K   ) - GDPM( I,J,K+1 )
 1100 CONTINUE

      CALL RESET ( GTTZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTUZF, IDIM*JDIM*KMAX )
      CALL RESET ( GTVZF, IDIM*JDIM*KMAX )
*
*"   < 2. Shapiro $B%U%#%k%?!<$K$h$kJQ2=(B >
*
      DO 2200 J=1,JDIM
         DO 2200 I=1,IDIM
            GTTZF(I,J,1) = SH/2.0*(GDT(I,J,2)-GDT(I,J,1))
            GTUZF(I,J,1) = SM/2.0*(GDU(I,J,2)-GDU(I,J,1))
            GTVZF(I,J,1) = SM/2.0*(GDV(I,J,2)-GDV(I,J,1))
            DO 2100 K=2, KMAX-1
               GTTZF(I,J,K)
     &            = SH/2.0*(GDT(I,J,K-1)-2.0*GDT(I,J,K)+GDT(I,J,K+1))
               GTUZF(I,J,K)
     &            = SM/2.0*(GDU(I,J,K-1)-2.0*GDU(I,J,K)+GDU(I,J,K+1))
               GTVZF(I,J,K)
     &            = SM/2.0*(GDV(I,J,K-1)-2.0*GDV(I,J,K)+GDV(I,J,K+1))
 2100       CONTINUE 
            GTTZF(I,J,KMAX) 
     &         = SH/2.0*(GDT(I,J,KMAX-1)-GDT(I,J,KMAX))
            GTUZF(I,J,KMAX)
     &         = SM/2.0*(GDU(I,J,KMAX-1)-GDU(I,J,KMAX))
            GTVZF(I,J,KMAX)
     &         = SM/2.0*(GDV(I,J,KMAX-1)-GDV(I,J,KMAX))
 2200 CONTINUE 
*
*"   < 3. $B29EY$K$D$$$F$N$_%(%M%k%.!<J]B8$?$a$NJd@5(B >
*
      DO 3100 I = 1,IDIM
         DO 3100 J = 1,JDIM
            SUMTDP = 0.0
            SUMADP = 0.0
c            write (6,*) ' in p2zfltEA'
            DO 3200 K = 1, KMAX
               SUMTDP = SUMTDP + GTTZF(I,J,K) * DELP(I,J,K)
               SUMADP = SUMADP + DELP(I,J,K)
c               write (6,*) i,j,k,gttzf(i,j,k),delp(i,j,k)
 3200       CONTINUE 
c            write ' after 3200 loop'
c            write i,j,sumtdp, sumadp
            DO 3300 K=1,KMAX
               GTTZF(I,J,K) = GTTZF(I,J,K) - SUMTDP/SUMADP
 3300       CONTINUE 
 3100 CONTINUE 
*
*"   < 4. $BJQ2=NL(B, $BJQ2=N(7hDj(B >
*
      DO 4100 I = 1, IDIM
         DO 4100 J = 1, JDIM
            DO 4100 K=1,KMAX
               GDT(I,J,K) = GDT(I,J,K) + GTTZF(I,J,K)
               GTTZF(I,J,K) = GTTZF(I,J,K)/DELTA
               GDU(I,J,K) = GDU(I,J,K) + GTUZF(I,J,K)
               GTUZF(I,J,K) = GTTZF(I,J,K)/DELTA
               GDV(I,J,K) = GDV(I,J,K) + GTVZF(I,J,K)
               GTVZF(I,J,K) = GTTZF(I,J,K)/DELTA
 4100 CONTINUE 
*
      RETURN
      END


